/*  BV2SMV: Tool for Translating QF_BV problems into SMV.
 *
 *  Copyright (C) 2013 Andreas Fröhlich and Gergely Kovásznai, FMV, JKU Linz.
 *
 *  All rights reserved.
 *
 *  This file is part of BV2SMV.
 *  See COPYING for more information on using this software.
 */

#ifndef BV2SMV_BV_H_
#define BV2SMV_BV_H_

#include "bv2smv.h"
#include "smt2.h"

bv2smv_term * bv2smv_var_create(bv2smv * bv2smv, char * name, unsigned int width);
bv2smv_term * bv2smv_const_create(bv2smv * bv2smv, char * value);

bv2smv_term * bv2smv_opTerm_create(BtorSMT2ParseOpt * parseOpt, bv2smv_opType opType, bv2smv_term * x, bv2smv_term * y);
bv2smv_term * bv2smv_binOp_create(bv2smv * bv2smv, bv2smv_opType opType, bv2smv_term * x, bv2smv_term * y);
bv2smv_term * bv2smv_ite_create(BtorSMT2ParseOpt * parseOpt, bv2smv_term * cond, bv2smv_term * x, bv2smv_term * y);
bv2smv_term * bv2smv_ineq_create(BtorSMT2ParseOpt * parseOpt, bv2smv_opType opType, bv2smv_term * x, bv2smv_term * y);
bv2smv_term * bv2smv_shift_create(BtorSMT2ParseOpt * parseOpt, bv2smv_opType opType, bv2smv_term * x);
bv2smv_term * bv2smv_indexing_create(BtorSMT2ParseOpt * parseOpt, bv2smv_term * x, unsigned int index);

#endif /* BV2SMV_BV_H_ */
