/*  BV2SMV: Tool for Translating QF_BV problems into SMV.
 *
 *  Copyright (C) 2013 Andreas Fröhlich and Gergely Kovásznai, FMV, JKU Linz.
 *
 *  All rights reserved.
 *
 *  This file is part of BV2SMV.
 *  See COPYING for more information on using this software.
 */

#ifndef BV2SMV_HELPER_H_
#define BV2SMV_HELPER_H_

#include "btorsmt2/btormem.h"
#include <string.h>

#define SWAP_POINTERS(x,y) { void * temp = y; y = x; x = temp; }

unsigned int ceillog10(unsigned long int x);

char * strCopy(BtorMemMgr * mm, const char * s);

char * strConcat(BtorMemMgr * mm, char delimiter, unsigned int count, ...);

#define STR_DELETE(mm, s) DELETEN(mm, s, strlen(s)+1)

#define NUM_ARGS(...)  (sizeof((char*[]){__VA_ARGS__})/sizeof(char*))
#define STR_CONCAT(mm, delimiter, ...) (strConcat(mm, delimiter, NUM_ARGS(__VA_ARGS__), ##__VA_ARGS__))

void strOverwriteSpaces(char * s, char c);

unsigned long int parseStrBin(const char * s);

#endif /* BV2SMV_HELPER_H_ */
