/*  BV2SMV: Tool for Translating QF_BV problems into SMV.
 *
 *  Copyright (C) 2013 Andreas Fröhlich and Gergely Kovásznai, FMV, JKU Linz.
 *
 *  All rights reserved.
 *
 *  This file is part of BV2SMV.
 *  See COPYING for more information on using this software.
 */

#ifndef BV2SMV_STACK_H_
#define BV2SMV_STACK_H_

#define BV2SMV_DECLARE_STACK(name, type)					\
  typedef struct name ## Stack name ## Stack;				\
  struct name ## Stack { type * start; type * top; type * end; }

#define BV2SMV_INIT_STACK(stack)  { (stack).start = (stack).top = (stack).end = 0; }

/*#define BV2SMV_ADJUST_STACK(stack,size)				\
  do {									\
    size_t old_size;							\
    if ((size) > 0 && (old_size = BV2SMV_SIZE_STACK(stack)) < (size))	\
      {									\
	size_t elem_bytes = sizeof(*(stack).start);			\
	size_t old_count = BV2SMV_COUNT_STACK (stack);			\
	(stack).start = dqbf_mem_reallocate(((stack).start,		\
				      old_size * elem_bytes,		\
				      size * elem_bytes);		\
	(stack).top = (stack).start + old_count;			\
	(stack).end = (stack).start + size;				\
      }									\
  }while(0)								\
*/
#define BV2SMV_COUNT_STACK(stack) ((size_t) ((stack).top - (stack).start))
#define BV2SMV_EMPTY_STACK(stack) ((stack).top == (stack).start)
#define BV2SMV_RESET_STACK(stack) { (stack).top = (stack).start; }

#define BV2SMV_SIZE_STACK(stack) ((stack).end - (stack).start)
#define BV2SMV_FULL_STACK(stack) ((stack).top == (stack).end)
#define BV2SMV_DELETE_STACK(mm, stack)					\
  {									\
		DELETEN(mm, (stack).start, BV2SMV_SIZE_STACK(stack));	\
    BV2SMV_INIT_STACK((stack));						\
  }
#define BV2SMV_ENLARGE_STACK(mm, stack)					\
  {									\
    size_t old_size = BV2SMV_SIZE_STACK(stack), new_size;		\
    new_size = old_size ? 2 * old_size : 1;				\
    size_t old_count = BV2SMV_COUNT_STACK(stack);			\
    BTOR_REALLOC((mm), (stack).start, old_size, new_size);				\
    (stack).top = (stack).start + old_count;				\
    (stack).end = (stack).start + new_size;				\
  }

#define BV2SMV_PUSH_STACK(mm, stack, elem)	\
  {						\
    if (BV2SMV_FULL_STACK ((stack)))		\
      BV2SMV_ENLARGE_STACK ((mm), (stack));	\
    *((stack).top++) = (elem);			\
  }

#define BV2SMV_POP_STACK(stack) (*--(stack).top)

/*
 * Print ALL the elements of a stack.
 * 		printFunction: pointer to the function that prints an element
 */
/*#define BV2SMV_PRINT_STACK(dqbf, stack, printFunction)					\
  {									\
  	size_t i, count;				\
  	for (i = 0, count = BV2SMV_COUNT_STACK(stack); i<count; i++)			\
			(*printFunction)(dqbf, *((stack).start + i));						\
  }*/

//*((stack).start + i)
/*
 //BV2SMV_DECLARE_STACK (Int, int);
 //BV2SMV_DECLARE_STACK (UInt, unsigned int);
 BV2SMV_DECLARE_STACK (VoidPtr, void *);
 //BV2SMV_DECLARE_STACK (VarPtr, Var *);*/

#endif /* BV2SMV_STACK_H_ */
